﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SpaceTransformationExample
{
    class WorldObject
    {
        public WorldObject Parent { get; set; }
        public Vector2 PositionInParentSpace { get; set; }
        public float RotationInParentSpace { get; set; }

        public Texture2D Texture;
        public Vector2 TextureOrigin;


        public WorldObject(Texture2D texture)
        {
            Texture = texture;
            TextureOrigin = new Vector2(texture.Width, texture.Height) / 2;
            Parent = null;
            PositionInParentSpace = Vector2.Zero;
            RotationInParentSpace = 0.0f;
        }

        public WorldObject(Texture2D texture, WorldObject parent)
        {
            Texture = texture;
            TextureOrigin = new Vector2(texture.Width, texture.Height) / 2;
            Parent = parent;
            PositionInParentSpace = Vector2.Zero;
            RotationInParentSpace = 0.0f;
        }



        public Vector2 PositionInWorldSpace
        {
            get
            {
                // TODO:  Fill me in!
                //     Calculate my postion in world space, using my position in parent space
                //     (and the postion and rotation of all of my ancestors)
                //     return this calculated postion in world space

                Vector2 calculatedPostionInWorldSpace = Vector2.Zero;

                return calculatedPostionInWorldSpace;
            }
            set
            {
                // TODO:  Fill me in!
                //     Given "value" (postion in world space), calculate that postion in
                //     my parent's space, and then set PositionInParentSpace accordingly.
                Vector2 worldSpacePosition = value;
            }
        }

        public float RotationInWorldSpace
        {
            get
            {
                // Get the rotation of the object in world space
                //   (combination of rotations of parents)
                return 0.0f;
            }
            set
            {
                // Given the rotation of the object in world space,
                //   set the rotation of the object in parent space
                float worldRotation = value;
            }
        }
    }
}
